'Compilable Example:
#Compile Exe  "gbDocker.exe"
#Dim All
#Debug Error On
#Include "Win32API.inc"
#Resource Icon logoico "gbdocker.ico"
#Resource Bitmap logobmp "gbdocker.bmp"

$Ver = "gbDocker v1.0     "
%IDC_Image = 500
%ID_Timer  = 501

Global hDlg As Dword, AutoDock, Docked As Long
Global xPreRollup, yPreRollup, wPrerollup, hPreRollup As Long

Function PBMain() As Long
   Dialog New Pixels, 0, $Ver,300,300,250,250, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "logoico"
   Control Add Image, hDlg, %IDC_Image, "logobmp",0,0,47,47, %WS_Border
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local PS As PaintStruct, w,h As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         If Docked Then SetTimer(hDlg, %ID_Timer, 500, ByVal %NULL)
      Case %WM_Destroy
         Settings_INI "save"
      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Loc hDlg, %IDC_Image, (w-48)/2,(h-48)/2
      Case %WM_Timer
         Dialog Set Text hDlg, $Ver + Time$
      Case %WM_NCLButtonDblClk
         RollUpWindowAndDock
         Function = 1
   End Select
End Function

Sub Settings_INI(Task$)
   Local i,x,y As Long, xResult, yResult, INIFileName, tempz As AsciiZ * %Max_Path
   INIFileName = Exe.Path$ + "gbdocker.ini"
   'set ini filename
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "500", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "500", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "250", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "250", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for numeric variables
      Getprivateprofilestring "All", "xPreRollup", "500", tempz, %Max_Path, INIFileName:  xPreRollup = Val(tempz)
      Getprivateprofilestring "All", "yPreRollup", "500", tempz, %Max_Path, INIFileName:  yPreRollup = Val(tempz)
      Getprivateprofilestring "All", "wPreRollup", "250", tempz, %Max_Path, INIFileName:  wPreRollup = Val(tempz)
      Getprivateprofilestring "All", "hPreRollup", "250", tempz, %Max_Path, INIFileName:  hPreRollup = Val(tempz)
      Getprivateprofilestring "All", "AutoDoc", "1", tempz, %Max_Path, INIFileName:  AutoDock = Val(tempz)
      Getprivateprofilestring "All", "Docked", "0", tempz, %Max_Path, INIFileName:  Docked = Val(tempz)
   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save numeric variables
      WritePrivateProfileString "All", "xPreRollup", (Str$(xPreRollup)), INIFileName
      WritePrivateProfileString "All", "yPreRollup", (Str$(yPreRollup)), INIFileName
      WritePrivateProfileString "All", "wPreRollup", (Str$(wPreRollup)), INIFileName
      WritePrivateProfileString "All", "hPreRollup", (Str$(hPreRollup)), INIFileName
      WritePrivateProfileString "All", "AutoDock", (Str$(AutoDock)), INIFileName
      WritePrivateProfileString "All", "Docked", (Str$(Docked)), INIFileName
   End If
End Sub

Sub RollupWindowAndDock
    Local x,y,w,h,wClient,hClient,deskW,deskH,M,wDock As Long
    M = 20 : wDock = 270  'margin
    Dialog Get Client hDlg To wClient, hClient
    Dialog Get Loc    hDlg To x,y
    Desktop Get Client To deskW, deskH

    If hClient < 10 Then  'MAKE LARGE - starts small, so make big and undock if required
       Docked = 0 : KillTimer hDlg, %ID_Timer : Dialog Set Text hDlg, "gbDocker"
       Dialog Set Client hDlg, wPreRollup, hPreRollup
       If (x=deskW-wDock-M) And (y=deskH-2*M) Then Dialog Set Loc  hDlg, xPreRollup, yPreRollup   'restore location if not moved from docking location

       Dialog Get Loc hDlg To x,y
       Dialog Get Size hDlg To w,h
       Dialog Set Loc hDlg, IIf((x+w)>deskW, deskW-w-M,x), IIf((y+h)>deskH, deskH-h-M,y)

    Else                  'make small  - start big, so make small and dock if required
       If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
          Dialog Get Client hDlg To wPreRollup, hPreRollup
          Dialog Get Loc  hDlg To xPreRollup, yPreRollup
          Dialog Set Client hDlg, wPreRollup, 0
       End If
       If AutoDock Then
          Docked = 1
          SetTimer(hDlg, %ID_Timer, 500, ByVal %NULL)
          Dialog Set Client hDlg, wDock, 0
          Dialog Set Loc hDlg, (deskW-wDock-M),(deskH-2*M)
       End If
    End If
End Sub
